# nonoverlap_exon_sort gene_nonoverlap_exon nonoverlap_exon_read read exon_zb gene_zb

# "read";    # gid, eid, pos, read 1,read 2,...,
# "exonzb";  # eid, start read num, end read num (in the read file), exon length for each exon
# "genezb";  # gid, start exon num, end exon num (in the read file), gene length for each gene

unless (open (ZERFILE, "$ARGV[0]")) {
              die ("cannot open input file $ARGV[0]\n");
      } 
unless (open (ONEFILE, "$ARGV[1]")) {
              die ("cannot open input file $ARGV[1]\n");
      } 
      
unless (open (OUTFILE1, ">$ARGV[3]")) {
           die ("cannot open output file $ARGV[3]\n");
      }
unless (open (OUTFILE2, ">$ARGV[4]")) {
           die ("cannot open output file $ARGV[4]\n");
      }
unless (open (OUTFILE3, ">$ARGV[5]")) {
           die ("cannot open output file $ARGV[5]\n");
      }

          	    
      @line=<ZERFILE>;
      for($i=1;$i<=$#line;$i++){
      	  chomp($line[$i]);
      	  @temp=split(/\t/,$line[$i]);
      	  $elen[$temp[5]]=$temp[2]-$temp[1]+1;
      }
      @line=();
      close(ZERFILE);	  
      
    	$p1=1;
      $e1=1;
      
      @gline=<ONEFILE>;
      for($f=1;$f<=10;$f++){
          $i1=($f-1)*1952+1;
          $i2=$f*1952;
          if($f==10){$i2=$#gline;}
          
          $min=1000000;
          $max=-1;
          for($i=$i1;$i<=$i2;$i++){
      	       chomp($gline[$i]);
      	       @temp=split(/\t/,$gline[$i]);
      	       @tmp=split(/,/,$temp[2]);
      	       foreach $wd(@tmp){
      	       	  if($wd>$max){$max=$wd;}
      	       	  if($wd<$min){$min=$wd;}
      	       }
      	  }
      	  print"$f $min $max\n";
      	  
      	  unless (open (TWOFILE, "$ARGV[2]")) {
              die ("cannot open input file $ARGV[2]\n");
          } 
          %data=();
      	  while(<TWOFILE>){
      	       chomp($_);
      	       $line=$_;
      	       @temp=split(/ /,$line);
      	       if($temp[0]>=$min && $temp[0]<=$max){
      	       	   $data{$temp[0]}.=$line."\n";
      	       }	   	     	  
      	       if($temp[0]>$max){
      	       	   last;
      	       }
      	  }
      	  close(TWOFILE);
      	  
      	  for($i=$i1;$i<=$i2;$i++){
      	       @temp=split(/\t/,$gline[$i]);
      	       @tmp=split(/,/,$temp[2]);
      	       $shu=0;
      	       $glen=0;
      	       for($j=0;$j<=$#tmp;$j++){
      	       	   if($data{$tmp[$j]} ne ""){
      	       	      @zs=split(/\n/,$data{$tmp[$j]});
      	       	      @ps=();
      	       	      @dt=();
      	       	      $q=0;
      	       	      foreach $se(@zs){
      	       	      	 @tp=split(/ /,$se);
      	       	      	 $ps[$q]=$tp[1];
      	       	      	 $dt[$q]=$se;
      	       	      	 $q++;
      	       	      }	 
      	       	      for(sort{$ps[$a]<=>$ps[$b]}0..$#ps){
      	       	         print(OUTFILE1 "$i $dt[$_]\n");
      	       	      }	 
      	       	      $p2=$p1+$q-1; #$q will be >0
      	       	      print(OUTFILE2 "$tmp[$j] $p1 $p2 $elen[$tmp[$j]]\n");
      	       	      $p1=$p2+1;
      	       	      $shu++;
      	       	   }    
      	       	   $glen+=$elen[$tmp[$j]];
      	       }
      	       if($shu>0){
      	           $e2=$e1+$shu-1;
      	           print(OUTFILE3 "$temp[0] $e1 $e2 $glen\n");
      	           $e1=$e2+1;
      	       }      	
      	  }
      	 
     }
     @gline=();
     close(ONEFILE);
     
     close(OUTFILE1);
     close(OUTFILE2);
     close(OUTFILE3);
