#!/usr/usc/bin/perl

use strict;
open(IN,$ARGV[0]);
open(OUT,">$ARGV[1]");
my $tissue = $ARGV[2];

my $line;
my @data;
my $cnt = 0;
my %read_num;
my %chr;  
while($line = <IN>)
{
  chomp($line);

  @data = split(/	/,$line);
  if($#data == 11)
  {
    my $strand;

    if($data[1] == 0)
    {
      $strand = '+'; 
    }
    else
    {
      $strand = '-';
    }

    my @data2 = split(/:/,$data[11]);


    my @name = split(/~/,$data[0]);
    my @data3 = split(/M/,$data[5]);
    my @data4 = split(/N/,$data3[1]);
    
    if($#name==1)
    {
      my $start = $data[3]+$data3[0]-1;
      $chr{$data[2]}{$start}++;
    }
  }
    
}


my $key;
foreach $key(sort {$a <=> $b} keys %chr)
{
  my %hash = %{$chr{$key}};

  my $key2;

  foreach $key2(sort {$a <=> $b} keys %hash)
  {
    print OUT "$key $key2 $chr{$key}{$key2} $tissue\n";
  }
}
close(IN);
close(OUT);


