# echo 'cd $PBS_O_WORKDIR; perl nonoverlap_exon_read.pl nonoverlap_exon_sort junction_read nonoverlap_exon_read uniq_tt' | qsub -q cmb -l vmem=10g,mem=10g,nodes=1:ppn=1,walltime=10:00:00

# nonoverlap_exon_read: eid, pos, exp1, exp2....
# uniq_tt: total number of uniq reads

# junction reads are not sorted

unless (open (OUTFILE2, ">$ARGV[3]")) {
              die ("cannot open input file $ARGV[3]\n");
      } 
unless (open (OUTFILE, ">$ARGV[2]")) {
              die ("cannot open output file $ARGV[2]\n");
          }
unless (open (ONEFILE, "$ARGV[0]")) {
             die ("cannot open input file $ARGV[0]\n");
      } 

            
      @aline=<ONEFILE>;
      $k=0;
      for($i=1;$i<=$#aline;$i++){
      	  chomp($aline[$i]);
      	  @temp=split(/\t/,$aline[$i]);
      	  if($id{$temp[0]} eq ""){
      	      $fchr[$k]=$temp[0];
      	      $id{$temp[0]}=1; 
      	      $k++;
      	  }    
      }	
      %id=();
      close(ONEFILE);
     
open(IN,$ARGV[4]);
$ctr=0;
push(@file,0);
while($line = <IN>)
{
  chomp($line);
  $ctr++;
  push(@file,$line);
  print $line,"\n";
}
close(IN); 
for($f=1;$f<=$ctr;$f++){
   $tt[$f]=0;
}
print $ctr,"\n";
print "@file\n"; 
          	
for($q=0;$q<=$#fchr;$q++)
{
   @n=();
   @sk=();
   @beg=();%beg=();
   @cnt=();%cnt=();
          
   for($f=1;$f<=$ctr;$f++){
      unless (open (TWOFILE, "$file[$f]")) {
          die ("cannot open input file $file[$f]\n");
      }
      $n[$f]=0;
      $sk[$f]=1;
      while(<TWOFILE>){
         chomp($_);
         $line=$_;
         @temp=split(/ /,$line);
         if($temp[0] eq $fchr[$q]){
             $n[$f]++;
             $beg[$n[$f]][$f]=$temp[1];
             $cnt[$n[$f]][$f]=$temp[2];
             $tt[$f]+=$temp[2];
         }	
         if($n[$f]>0 && $temp[0] ne $fchr[$q]){
             last;
         }	
      }
      close(TWOFILE);
   }
          
          %jct1=();@jct1=();
          unless (open (THRFILE, "$ARGV[1]")) {
              die ("cannot open input file $ARGV[1]\n");
          } 
          while(<THRFILE>){
              chomp($_);
              $line=$_;
              @temp=split(/ /,$line);
              if($temp[0] eq $fchr[$q]){
              	  $jct1{$temp[1]}[$temp[3]]=$temp[2];
                  $tt[$temp[3]]+=$temp[2];
              }	  
          }
          close(THRFILE);
          print "$fchr[$q]\n";
          
          $bj=0;
          for($i=1;$i<=$#aline;$i++){
               @temp=split(/\t/,$aline[$i]);
               if($temp[0] eq $fchr[$q]){
                   $bj=1;
                   %mk=();
                   %shu1=();@shu1=();
                   for($f=1;$f<=$ctr;$f++){
                       $mark=0;
                       for($k=$sk[$f];$k<=$n[$f];$k++){
                       	    if($beg[$k][$f]>=$temp[1] && $beg[$k][$f]<=$temp[2]){
                       	         if($mark==0){$sk[$f]=$k;$mark=1;}
                       	         $mk{$beg[$k][$f]}=1;
                       	         $shu1{$beg[$k][$f]}[$f]=$cnt[$k][$f];
                       	    }
                       	    if($beg[$k][$f]>$temp[2]){last;}
                       }
                   }   
                   for($j=$temp[1];$j<=$temp[2];$j++){
                   	  for($f=1;$f<=$ctr;$f++){
                   	      if($jct1{$j}[$f] ne ""){
                   	         $mk{$j}=1;
                   	         $shu1{$j}[$f]+=$jct1{$j}[$f];
                   	      }
                   	   }
                   }	        
                   foreach $ky(keys%mk){
                       print(OUTFILE "$temp[5] $ky");
                       for($f=1;$f<=$ctr;$f++){
                   	       if($shu1{$ky}[$f] eq ""){$shu1{$ky}[$f]=0;}
                   	       print(OUTFILE " $shu1{$ky}[$f]");
                       }
                       print(OUTFILE "\n");
                   }
               }
               if($bj==1 && $temp[0] ne $fchr[$q]){last;}
          }      
      }
      
     
      
      for($f=1;$f<=$ctr;$f++){
          print(OUTFILE2 "$tt[$f]\n");
      }    	
      close(OUTFILE2);
      close(OUTFILE);
